close all
clear all
clc


T=20;
C=[9.45;0.05;0.9];
I=[66;0.17;0.22;-11.3];
R=[0.56;0.0005;0.014;-0.09;0.43];
Sigma=diag([11^2 24^2 0.85^2 0]);
Sigma_w=diag([1 1]);

u=[zeros(1,T);10*ones(1,T);ones(1,T)];
x_0=zeros(4*4,1);
S_x0=eye(4*4)*0.1;

[A,B,C,D,Sigma_v,Sigma_w]=state_space_Pindyck(C,I,R,Sigma,Sigma_w);

[x,y]=simul_SS_model(A,B,C,D,Sigma_v,Sigma_w,u,x_0);

[x_p, S_p, x_f, S_f, x_s, S_s] = kalman(y, A, C, Sigma_v, Sigma_w, x_0, S_x0, u, B, D);

f1=figure;
set(f1,'Name','Spotreba');
plot((1:T),[x(1,:);x_f(1,:);x_s(1,:)])
legend('skutecnost','filtr','smoother','Location','Best')

f2=figure;
set(f2,'Name','Investice');
plot((1:T),[x(2,:);x_f(2,:);x_s(2,:)])
legend('skutecnost','filtr','smoother','Location','Best')

f3=figure;
set(f3,'Name','Urokova mira');
plot((1:T),[x(3,:);x_f(3,:);x_s(3,:)])
legend('skutecnost','filtr','smoother','Location','Best')

f4=figure;
set(f4,'Name','HDP');
plot((1:T),[x(4,:);x_f(4,:);x_s(4,:)])
legend('skutecnost','filtr','smoother','Location','Best')

sse_f=sum((x-x_f).^2,2);
sse_s=sum((x-x_s).^2,2);
sum(sse_f);
sum(sse_s);

disp('suma ctvercu chyb filtru')
disp(['spotreba: ',num2str(sum((x(1,:)-x_f(1,:)).^2))])
disp(['investice: ',num2str(sum((x(2,:)-x_f(2,:)).^2))])
disp(['urokova mira: ',num2str(sum((x(3,:)-x_f(3,:)).^2))])
disp(['HDP: ',num2str(sum((x(4,:)-x_f(4,:)).^2))])
disp(' ')
disp('suma ctvercu chyb smootheru')
disp(['spotreba: ',num2str(sum((x(1,:)-x_s(1,:)).^2))])
disp(['investice: ',num2str(sum((x(2,:)-x_s(2,:)).^2))])
disp(['urokova mira: ',num2str(sum((x(3,:)-x_s(3,:)).^2))])
disp(['HDP: ',num2str(sum((x(4,:)-x_s(4,:)).^2))])

save data_Pindyck_Rubinfeld.mat A B C D x y x_0 S_x0 Sigma_v Sigma_w u