function [A,B,C,D,Sigma_v,Sigma_w]=state_space_Pindyck(C,I,R,Sigma,Sigma_w)
% zadani viz priklad 4.2.1 ds.pdf
% vstupy: C,I,R vektory koeficientu P-R modelu (viz (4.1a)-(4.1c))
%          u ... hodnoty exogennich velicin M(t)-M(t-1) a G(t)
%         Sigma ... kovariancni matice soku
%         Sigma_w ... kovariancni matice sumu mereni    
      
alpha0=[0 0 0 C(2)
        0 0 0 I(2)
        0 0 0 R(2)+R(3)
        1 1 0 0];
    
alpha1=[C(3) 0 0 0
        0 0 0 I(2)
        0 0 R(5) -R(3)
        0 0 0 0];
alpha2=[0 0 0 0
        0 0 0 -I(2)
        0 0 R(5) 0
        0 0 0 0];
alpha3=zeros(4);
alpha4=[0 0 0 0
        0 0 I(4) 0
        0 0 0 0
        0 0 0 0];
beta=[0 0 C(1)
      0 0 I(1)
      R(4) 0 R(1)
      0 1 0];
  
pom_inv=inv(eye(4)-alpha0);
A=[pom_inv*alpha1 pom_inv*alpha2 pom_inv*alpha3 pom_inv*alpha4;
    eye(3*4) zeros(3*4,4)];
B=[pom_inv*beta;
    zeros(3*4,3)];

C=[zeros(2,2) eye(2) zeros(2,3*4)];
D=zeros(2,3);

Sigma_v=[pom_inv*Sigma*pom_inv' zeros(4,3*4);zeros(3*4,4*4)];

eigenvalues=eig(A);
rho_A=max(abs(eigenvalues));% spektralni polomer  matice A
if rho_A<1%stabilni system
    disp('system je stabilni')
else
    disp('system je nestabilni')
end

